unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  NMHttp, Psock, NMFtp,ShellAPI, ShlObj, Buttons, StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    edDirectory: TEdit;
    Label2: TLabel;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    NMFTP1: TNMFTP;
    NMHTTP1: TNMHTTP;
    edUser: TEdit;
    edPassword: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    ProgressBar1: TProgressBar;
    ListBox1: TListBox;
    PopupMenu1: TPopupMenu;
    NewURL1: TMenuItem;
    DeleteURL1: TMenuItem;
    SpeedButton3: TSpeedButton;
    procedure Log(Str:string);
    procedure DownloadFTP(Host:string;FileName:string;User:string;Password:string);
    procedure DownloadHTTP(FileName:string);
    procedure SpeedButton1Click(Sender: TObject);
    procedure NMFTP1PacketRecvd(Sender: TObject);
    procedure NMFTP1UnSupportedFunction(Trans_Type: TCmdType);
    procedure NMFTP1Failure(var Handled: Boolean; Trans_Type: TCmdType);
    procedure NMFTP1Disconnect(Sender: TObject);
    procedure NMFTP1Connect(Sender: TObject);
    procedure NMFTP1AuthenticationFailed(var Handled: Boolean);
    procedure NMFTP1Status(Sender: TComponent; Status: String);
    procedure SpeedButton2Click(Sender: TObject);
    procedure edDirectoryExit(Sender: TObject);
    procedure NewURL1Click(Sender: TObject);
    procedure DeleteURL1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton3Click(Sender: TObject);
    procedure NMHTTP1Status(Sender: TComponent; Status: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dir:string;
  Form1: TForm1;
  f:file of byte;
  uze:longint;
implementation

{$R *.DFM}

function BrowseDialog(const Title: string; const Flag: integer): string;
var
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of char;
  TempPath : array[0..MAX_PATH] of char;
begin
  Result:='';
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  with BrowseInfo do begin
    hwndOwner := Application.Handle;
    pszDisplayName := @DisplayName;
    lpszTitle := PChar(Title);
    ulFlags := Flag;
  end;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then begin
    SHGetPathFromIDList(lpItemID, TempPath);
    Result := IncludeTrailingBackslash(TempPath);
    GlobalFreePtr(lpItemID);
  end;
end;

procedure tform1.Log(str:string);
var
  f:textfile;
begin
  assignfile(f,'log.txt');
  append(f);
  writeln(f,str);
  closefile(f);
end;

procedure TForm1.DownloadFTP(Host:string;FileName:string;User:string;Password:string);
begin
  nmftp1.Host := host;
  nmftp1.UserID := user;
  nmftp1.Password := password;
  panel1.caption:='  '+host;
  log('  '+host);
  try
    nmftp1.connect;
  except
    panel1.caption:='    '+host;
    log('  ');
    exit;
  end;
  nmftp1.mode(MODE_IMAGE);
  panel1.caption:='  '+filename;
  log(' ');

  dir:=filename;
  while pos('/',dir)>0 do
  delete(dir,1,(pos('/',dir)));
  if fileexists(edDirectory.text+dir) then
  try
    assignfile(f,edDirectory.text+dir);
    reset(f);
    uze:=filesize(f);
    closefile(f);
    nmftp1.DownloadRestore(filename,edDirectory.text+dir);
    log('!   ');
  except
    log('   .  .');
    nmftp1.Download(filename,edDirectory.text+dir);
  end
  else
  begin
    nmftp1.Download(filename,edDirectory.text+dir);
    uze:=0;
  end;

  panel1.caption:='!';
  log(' ');
  nmftp1.disconnect;
end;

procedure TForm1.DownloadHTTP(FileName:string);
var
  dir:string;
begin
  nmhttp1.Host := filename;
  dir:=filename;

  while pos('/',dir)>0 do
  delete(dir,1,(pos('/',dir)));

  nmhttp1.body := edDirectory.text+dir;
  panel1.caption:='  '+filename;
  log('');
  try
    nmhttp1.connect;
  except
    panel1.caption:='    '+filename;
    log(' ...');
    exit;
  end;
  panel1.caption:='  '+filename;
  log(' ');

  try
    nmhttp1.get(filename);
  except
    panel1.caption:='  '+filename;
    log(' ...');
  end;

  panel1.caption:='!';
  log(' ');
  nmhttp1.disconnect;
end;
procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  d,kind,host,fil,dir:string;
begin
  if listbox1.Items.Count =0 then exit;
  if listbox1.itemindex<0 then listbox1.itemindex:=0;
  d:=listbox1.Items[listbox1.itemindex];

  log('  '+listbox1.Items[listbox1.itemindex]);

  try
    mkdir(edDirectory.text);
  except
  end;

  kind:=copy(d,1,6);
  if kind='ftp://' then
  begin
    fil:=d;
    delete(fil,1,6);
    host:=copy(fil,1,(pos('/',fil)-1));
    delete(fil,1,(pos('/',fil)-1));
    downloadftp(host,fil,edUser.text,edPassword.text);
  end
  else
  if kind='http:/' then
  begin
    delete(d,1,7);
    downloadhttp(d);
  end
  else panel1.caption:='URL    http://  ftp://';

  if listbox1.itemindex+1<listbox1.items.count then
  begin
    listbox1.itemindex:=listbox1.itemindex+1;
    form1.SpeedButton1Click(form1);
  end;
end;

procedure TForm1.NMFTP1PacketRecvd(Sender: TObject);
var
  i,k:longint;
  f:textfile;
begin
  panel1.Caption := ' '+IntToStr(NMFTP1.BytesRecvd+uze)+'   '+IntToStr(NMFTP1.BytesTotal);
  progressbar1.position:=strtoint(floattostr(int((NMFTP1.BytesRecvd+uze)*100/NMFTP1.BytesTotal)));
end;

procedure TForm1.NMFTP1UnSupportedFunction(Trans_Type: TCmdType);
begin
    log('  ');
case Trans_Type of
    cmdDownRestore: Memo1.Lines.Add('DownloadRestore    ');
    cmdDownload: Memo1.Lines.Add('Download    ');
    cmdReInit: Memo1.Lines.Add('Reinitialize    ');
    cmdAllocate: Memo1.Lines.Add('Allocate    ');
    cmdNList: Memo1.Lines.Add('NList    ');

    cmdDoCommand: Memo1.Lines.Add('DoCommand    ');
    cmdCurrentDir: Memo1.Lines.Add('CurrentDir    ');
  end;
end;

procedure TForm1.NMFTP1Failure(var Handled: Boolean; Trans_Type: TCmdType);
begin
    log(' FTP');
  case Trans_Type of
    cmdChangeDir: Memo1.Lines.Add('  ChangeDir ');
    cmdList: Memo1.Lines.Add('  List ');
    cmdDownRestore: Memo1.Lines.Add('  DownloadRestore ');
    cmdDownload: Memo1.Lines.Add('  Download ');

    cmdReInit: Memo1.Lines.Add('  Reinitialize ');
    cmdAllocate: Memo1.Lines.Add('  Allocate ');
    cmdNList: Memo1.Lines.Add('  NList ');
    cmdDoCommand: Memo1.Lines.Add('  DoCommand ');
    cmdCurrentDir: Memo1.Lines.Add('  CurrentDir ');
  end;
end;

procedure TForm1.NMFTP1Disconnect(Sender: TObject);
begin
  panel1.caption:='';
  log('');
end;

procedure TForm1.NMFTP1Connect(Sender: TObject);
begin
  panel1.caption:='';
  log('FTP ');
end;

procedure TForm1.NMFTP1AuthenticationFailed(var Handled: Boolean);
var
  ThePass,
  TheID: String;
begin
  log('   ');
  if MessageDlg(' /  .  ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      NMFTP1.Password := edPassword.text;
      NMFTP1.UserID := edUser.Text;
      Handled := TRUE;
    end;
end;

procedure TForm1.NMFTP1Status(Sender: TComponent; Status: String);
begin
  if status='' then exit;

  if pos(#13#10,status)<>0 then
    status := copy(status,0,length(status)-2);
  Memo1.lines.add(status);
  log(status);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  nmftp1.Disconnect;
  close;
end;

procedure TForm1.edDirectoryExit(Sender: TObject);
begin
  if edDirectory.text[length(edDirectory.text)] <>'\' then edDirectory.text:= edDirectory.text+'\';
end;

procedure TForm1.NewURL1Click(Sender: TObject);
var
 e:string;
begin
  if inputquery('New URL','Enter new URL',e)
  then begin listbox1.Items.Add(e);
  log('  '+e); end;
end;

procedure TForm1.DeleteURL1Click(Sender: TObject);
begin
  listbox1.Items.Delete(listbox1.itemindex);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  f:textfile;
begin
  assignfile(f,'log.txt');
  rewrite(f);
  writeln(f,'');
  closefile(f);
  try
    listbox1.Items.LoadFromFile('downloads.lst');
  except
    log('     downloads.lst');
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  listbox1.items.SaveToFile('downloads.lst');
  log('');
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
   edDirectory.text := BrowseDialog('    ', BIF_RETURNONLYFSDIRS);
end;

procedure TForm1.NMHTTP1Status(Sender: TComponent; Status: String);
begin
  memo1.lines.add(status);
  log(status);
end;

end.
